package com.malk.ruisi.controller;

import cn.hutool.core.io.FileUtil;
import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.dingshiqi;
import com.malk.ruisi.service.impl.dingshiqiImpl;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilHttp;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.http.fileupload.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.io.File;
import java.io.IOException;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Configuration
@EnableScheduling
@ConditionalOnProperty(name = {"enable.scheduling"})
public class ScheduleTask {
    @Autowired
    private dingshiqi ds;
    @Value("${qiyuesuo.pdfbdurl}")
    private String PDFBDURL;

    @Value("${qiyuesuo.bdurl}")
    private String BDURL;
    @Autowired
    private YDClient ydClient;

    /**
     * 每月查询业务ID
     */
    @Scheduled(cron = "0 0 0 26 * ?")
//    @Scheduled(cron = "0/10 * * * * ?")
    public void syncRecruitSource() {
        try {
            System.out.println("开始上传业务ID");
            System.out.println(LocalDateTime.now());
            ds.getYWFLid();
            System.out.println("结束业务ID");
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }

    /**
     * 每月查询物理印章ID
     */
//    @Scheduled(cron = "0/1 * * * * ?")
    @Scheduled(cron = "0 0 0 26 * ?")
    public void syncRecruitSource1() {
        try {
            System.out.println("开始上传物理印章ID");
            System.out.println(LocalDateTime.now());
            ds.getYWFLid1();
            System.out.println("结束物理印章ID");
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }

//    @Scheduled(cron = "*/10 * * * *")
    public void syncRecruitSource3() {
        List<Map> datalist = (List<Map>) ydClient.queryData(YDParam.builder()
                .formUuid("FORM-F7B0E685C56E41FC939A581F8B7C2665PXPV")
                .build(), YDConf.FORM_QUERY.retrieve_search_form);
        for (Map map : datalist) {
            Map formData = (Map) map.get("formData");
            boolean flag = false;
            String sn = String.valueOf(formData.get("textField_lzns5l3l"));
            try {
                taskExecute(String.valueOf(formData.get("textField_lzns5l3l")), String.valueOf(formData.get("textField_lzns5l3k")));
                flag = true;
            } catch (McException e) {

            }
            if (flag) {
                ydClient.operateData(YDParam.builder()
                        .formInstanceId(sn)
                        .build(), YDConf.FORM_OPERATION.delete);
            }
        }

    }

    private void taskExecute(String instanceId, String taskId) {
        Map param3 = new HashMap();
        param3.put("x-acs-dingtalk-access-token", new dingshiqiImpl().getAccessToken_PJSS());
        Map body4 = new HashMap();
        body4.put("outResult", "AGREE");
        body4.put("appType", "APP_VCTRP6227CC8368NDOID");
        body4.put("systemToken", "5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
        body4.put("remark", "同意");
        body4.put("taskId", taskId);
        body4.put("processInstanceId", instanceId);
        body4.put("userId", "13810479803");
        String s1 = UtilHttp.doPost("https://api.dingtalk.com/v1.0/yida/tasks/execute", param3, null, (Map<String, Object>) body4);
        System.out.println("result" + s1);
    }

    /**
     * 每月查询电子印章ID
     * //
     */
    @Scheduled(cron = "0 0 0 26 * ?")
//    @Scheduled(cron = "0 0 0 * * ?")
    public void syncRecruitSource2() {
        try {
            System.out.println("开始上传电子印章ID");
            System.out.println(LocalDateTime.now());
            ds.getYWFLid2();
            System.out.println("结束电子印章ID");
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "0 1 0 * * SUN")
//    @Scheduled(cron = "0 0 * * 0")
//@Scheduled(cron = "0 0 0 * * ?")
    public void delTempFile() {
        log.info("开始删除文件");
        File directory = new File(BDURL);
        try {
            FileUtils.cleanDirectory(directory);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    //        @Scheduled(cron = "0/1 * * * * ?")
    public void syncDelete() {

        log.info("开始删除数据");

        try {
            ds.syncDelete();
            System.out.println(LocalDateTime.now());
        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }
}
